/////////////////////////////////////////////////////////////////////////////////
/// FILE:     rnd.hpp	 						      ///
/// CONTAINS: Definitions for RND problem classes	    	              ///
/// AUTHOR:   Manuel Vallejo Snchez 	10/05/1999 			      ///
/////////////////////////////////////////////////////////////////////////////////

// Radio Network Design - Calgari, Guidec, Kuonen and Klober...
//			 ...(Swiss Federal Institute of Technology)
// Artificial Grid (287 x 287 points)
// 49 transmiters distributed regulary plus 100 transmiters distributed randomly.
// Solution fitness ===> 204.08 


#define GRID_SIZE_X  	287    	//Artificial grid horizontal size.
#define GRID_SIZE_Y  	287    	//Artificial grid vertical size.
#define GRID_SIZE     82369	//Total grid size.
#define TRANS_NUMB   	149  	//Number of transmiters used.
			  	//49 transmiters distributed regulary...
				//... the rest is distributed randomly.

#define RANGE	      20   	//Transmiter cover range (square area)


#define MAX_FIT		204.08
#define AVG_A		-4.878
#define AVG_B		 4.878
#define DEV_A		 0.0
#define DEV_B		 2.404

// CLASS DEFINITION

class RND: public Problem
{
public:
	double Evaluate(double [], unsigned long);
private:
	double Evaluate1(double [], unsigned long);
	double Evaluate2(double [], unsigned long);
	double Evaluate3(double [], unsigned long);
	
};


////////////////////////////// End of file rnd.hpp ///////////////////////////
